/*
 * Copy me if you can.
 * by 20h
 */

#include <u.h>
#include <libc.h>
#include <auth.h>
#include <bio.h>
#include <ip.h>
#include <mp.h>
#include <ndb.h>
#include <libsec.h>

char be[] =
	"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";

char *
b64_enc(char *s, int l)
{
	char *ret, *o;
	int lr;

	lr = 0;
	ret = malloc(0);

	while(l > 0)
	{
		lr += 4;
		ret = realloc(ret, lr + 1);
		o = ret + lr - 4;
	
		o[0] = be[s[0] >> 2];
		o[1] = be[((s[0] & 3) << 4) | (s[1] >> 4)];
		o[2] = be[((s[1] & 0xF) << 2) | (s[2] >> 6)];
		o[3] = be[s[2] & 0x3F];

		if(l < 3)
			o[3] = '=';
		if(l < 2)
			o[2] = '=';

		s += 3;
		l -= 3;
	}
	ret[lr] = '\0';

	return ret;
}

char *
read_line(int s, int le)
{
	char *ret;
	int l;

	ret = nil;
	l = 0;

	if(le == -1)
		le = 512;

	while((ret = realloc(ret, ++l)) != nil && read(s, &ret[l - 1], 1) > 0 &&
			l < le)
	{
		if(l > 1)
		{
			if(ret[l - 2] == '\r')
			{
				ret[l - 1] = '\0';
				ret[l - 2] = '\0';
				return ret;
			}
		}
	}
	if(l >= le)
	{
		ret = realloc(ret, ++l);
		ret[le] = '\0';
		return ret;
	}

	if(ret != nil)
		free(ret);
	return nil;
}

char *
read_httphdr(int s)
{
	char *ret, chunk;
	int len;

	len = -1;
	chunk = 'n';

	while((ret = read_line(s, -1)) != nil && ret[0] != '\0')
	{
		if(strstr(ret, "Content-Length: "))
			len = atoi(ret + 16);
		if(strstr(ret, "Transfer-Encoding: chunked"))
			chunk = 'y';
		free(ret);
	}
	if(ret == nil)
		return nil;

	if(chunk == 'y')
	{
		ret = read_line(s, -1);
		if(ret != nil)
			free(ret);
	}

	ret = read_line(s, len);

	return ret;
}

char *
do_nat(char *mntp)
{
	int s;
	char *ret;

	ret = malloc(16);
	snprint(ret, 16, "%s/tcp", mntp);

	s = dial(netmkaddr("www.r-36.net", ret, "80"), 0, 0, 0);
	free(ret);
	if(s < 0)
		return nil;

	ret = "GET /IP.php HTTP/1.1\r\nHost: www.r-36.net\r\nConnection: Close\r\n\r\n";
	write(s, ret, strlen(ret));
	
	ret = read_httphdr(s);

	hangup(s);
	close(s);

	return ret;
}

char *
do_local(char *mntp)
{
	int s, l;
	char *ret, *b, *d;

	ret = malloc(16);
	snprint(ret, 16, "%s/ndb", mntp);

	s = open(ret, OREAD);
	free(ret);
	if(s < 0)
		return nil;

	l = 0;
	ret = malloc(0);
	while(realloc(ret, ++l) != nil && read(s, &ret[l - 1], 1) > 0 && 
			ret[l - 1] != ' ' && l < 512);
	close(s);
	if(ret == nil)
		return nil;

	ret[l - 1] = '\0';
	d = strchr(ret, '=');
	if(d == nil)
	{
		free(ret);
		perror("No '=' found in IP-string.\n");
		return nil;
	}

	b = strdup(d + 1);
	free(ret);
	return b;
}

char *
do_ndb(char *mntp, char *host)
{
	Ndbtuple *ndb, *ip;
	char *ret;

	ret = nil;

	ndb = dnsquery(mntp, host, "ip");
	if(ndb == nil)
		return ret;

	ip = ndbfindattr(ndb->entry, ndb->line, "ip");
	if(ip != nil)
		ret = strdup(ip->val);
	
	ndbfree(ndb);
	return ret;
}

void
usage(void)
{

	print("usage: [-nw] [-t inter] [-p port] [-x mntp] [-s host] [-d dynh]\n");
	return;
}

int
main(int argc, char *argv[])
{
	char *ohost, *host, *dolocal, *stack, *dyn, *port, *ret, *dynh, *wil, *buf, *buf2;
	UserPasswd *i;
	TLSconn conn;
	int s, ts, inter;

	stack = "/net";
	host = nil;
	dolocal = "y";
	port = "443";
	dyn = "members.dyndns.org";
	dynh = "desax-plan9.ath.cx";
	wil = "OFF";
	inter = -1;
	ohost = nil;
	
	ARGBEGIN {
		case 'n':
			dolocal = "n";
			break;
		case 'x':
			stack = EARGF(usage());
			break;
		case 'p':
			port = EARGF(usage());
			break;
		case 's':
			dyn = EARGF(usage());
			break;
		case 'd':
			dynh = EARGF(usage());
			break;
		case 'w':
			wil = "ON";
			break;
		case 't':
			inter = atoi(EARGF(usage())) * 6000;
			break;
		default:
			usage();
			exits(0);
	} ARGEND;

	i = auth_getuserpasswd(auth_getkey, "proto=pass server=%s service=%s", dyn, port);
	if(i == nil)
	{
		print("We need factotum for keymanagement.\n");
		free(host);
		exits(0);
	}

daemon_dyn:
	if(inter > 0 && ohost != nil)
		sleep(inter);

	if(host == nil)
	{
		host = do_ndb(stack, dynh);
		if(host == nil)
		{
			perror("do_ndb");
			exits("do_ndb");
		}
	}

	if(ohost != nil)
		free(ohost);
	ohost = host;
	switch(*dolocal)
	{
		case 'n':
			host = do_nat(stack);
			if(host == nil)
			{
				perror("do_nat");
				exits("do_nat");
			}
			break;
		default:
			host = do_local(stack);
			if(host == nil)
			{
				perror("do_local");
				exits("do_local");
			}
			break;
	};
	if(ohost != nil)
		if(!strcmp(ohost, host))
			goto daemon_dyn;

	ret = malloc(16);
	snprint(ret, 16, "%s/tcp", stack);
	s = dial(netmkaddr(dyn, ret, port), 0, 0, 0);
	free(ret);
	if(s < 0)
	{
		perror("dial");
		goto end_all;
	}

	ts = tlsClient(s, &conn);
	close(s);
	if(ts < 0)
	{
		perror("tlsClient");
		goto end_all;
	}
	s = ts;

	if(conn.cert != nil)
		free(conn.cert);

	buf = malloc(512);
	snprint(buf, 512, "%s:%s", i->user, i->passwd);
	buf2 = b64_enc(buf, strlen(buf));
	free(buf);

	ret = malloc(512);
	snprint(ret, 512, "GET /nic/update?system=dyndns&hostname=%s&myi"
		"p=%s&wildcard=%s&mx=&backmx= HTTP/1.1\r\nHost: %s\r\nUser-agent: Plan9\r\nAu"
		"thorization: Basic %s\r\nConnection: Close\r\n\r\n"
		, dynh, host, wil, dyn, buf2);
	free(buf2);

	ts = write(s, ret, strlen(ret));
	free(ret);
	if(ts < 0)
	{
		perror("write");
		goto end_all;
	}

	ret = read_httphdr(s);
	if(ret != nil)
	{
		print("%s\n", ret);
		free(ret);
	}

	if(inter > 0)
		goto daemon_dyn;

end_all:

	free(host);

	exits(0);
	return 0;
}
